##############################
##### Aula 1 - Introducao ao R
##############################

#-------------------------------
# Funcoes basicas do R e objetos
#-------------------------------

#### R como calculadora

# Adicao
1 + 1 
1 + 1  + 1
45 + 68
(4+4) + 60
(2 + 3) * 60
4 + 34.5
.00000001 + .01
.021 + 87

# Subtracao
25 - 2
8 - 5
(4+4) - 60

# Multiplicacao
6*5
(4 + 5)*6
4 + (5*6)

# Divisao
250/25
(4 + 2)/3
4 + 2/3
10/3

# Resto de divisao
10%%3

# Potencia
2^10

# Raiz quadrada eoutras raizes
sqrt(100)
100^(1/2)
100^.5   #raiz quadrada
27^(1/3) #raiz cubica
8^(1/4)  #raiz quarta

# Exponencial (e^x)
exp(1) 
exp(2) 

# Logaritmo natural (base e)
log(4)
log(exp(1))

# Logaritmo em qualquer base
log(4)/log(10) # log de quatro na base 10
log(4,base=10)

# Uso de parentesis
1 + 3/4 + sqrt(65)
(1 + 3)/4 + sqrt(65)
1 + 3/(4 + sqrt(65))
(1 + 3)/(4 + sqrt(65))

#--------
# Objetos
#--------

# Podemos guardar informacoes e resultados dentro de "objetos". 
# Ou seja, objetos sao como "recipientes" de informacoes (de 
# qualquer tipo). Podemos salvar o numero 2 dentro de um objeto 
# chamado "x". Para isso simplesmente dizemos que x = 2. Depois, 
# para recuperar a informacao guardada dentro desse objeto, basta
# digitar seu nome e pressionar ENTER:
        
x = 2
print(x)
x #auto-printing
# Podemos ler a linha de comando acima de duas maneiras:
# -- atribuimos o valor 2 ao vetor "x"
# -- "x" recebe 2

# O operador de atribuicao tambem pode ser representado como <- 
x <- 5
x


# Objetos podem guardar resultados:
y = 4 + 5
y

# E podemos produzir novos resultados combinando objetos.
# Definimos que x=5 e 
# y=9. Logo, y-x deve ser 4.
y-x

#---------------------
#### Vetores (Parte 1)
----------------------

# Defincoes basicas

# Objetos podem guardar mais de uma informacao ao mesmo tempo.
# Para isso, devemos utilizar a funcao c(). **Funcoes sao
# comandos que tem o formato: funcao(). Requerem "inputs"
# (argumentos) e produzem um output ou resultado**. A funcao 
# c() sera o primeiro comando desse tipo que utilizaremos.
# Sua sintaxe e como se segue:
        
c(1,2,3,4,5,6)

# c() significa "combine". Com essa funcao, combinamos diversos
# valores num unico objeto, mais complexo, chamado **vetor**.
# Agora, _x_ sera um vetor que recebe os valores 1,2,3,4,5,6. 

x = c(1,2,3,4,5,6)
x
x = c(1 , 2 , 3 , 4 , 5 , 6)
x
y = c(2,2,2,2,2,2)
y

# E podemos fazer operacoes com vetores normalmente:

x+y #soma elemento-a-elemento
x-y #substracao elemento-a-elemento
x*y #multiplicacao elemento-a-elemento
x/y #divisao elemento-a-elemento

x %*% y # produto escalar (vetores sempre conformados a multiplicacao)
matx=matrix(c(x,7,8),2,4)
maty=matrix(c(y,2,2),8,1)
( matx%*%maty ) # deve conformar a multiplicacao
maty=matrix(c(y,2,2),2,4)
( matx%*%maty ) # deve conformar a multiplicacao
maty=matrix(c(y,2,2),4,2)
( matx%*%maty ) # sao conformadas a multiplicacao

sum(x*y) #funcao sum() soma todos os elementos do vetor

# Para verificar o numero de componentes de um vetor, usamos a funcao **length**
length(x)
length(y)
length(6)
length(x + y)

z <- x + y
z
length(z)

# Podemos tambem atribuir nomes aos componentes
b = c(24,29,22)
b
names(b)
names(b) = c("Aluno 1","Aluno 2","Aluno 3")
b
names(b)

# Dizemos que "names" e um atributo do vetor b
# Os nomes podem ser conferindo no proprio momento da criacao
# do vetor
alunos <- c(Aluno1 = 25, Aluno2 = 22, Aluno3 = 21)
alunos
names(alunos) # verificando os nomes de um objeto

# Posso combinar vetores (e nao apenas valores...)
alunos2 <- c(Aluno4 = 32, Aluno5 = 28, Aluno6 = 27)
alunos2

c(alunos,alunos2)

alunos <- c(alunos,alunos2)
alunos

#----------------------------------------------------
# Vetores (parte 2) - Introducao a classes de vetores
#----------------------------------------------------

# Ha varios tipos (classes) de vetores, e a classificacao
# depende do tipo de informacao que e armazenada. Vetores
# que contem numeros reais, sao chamados **numeric**. 
# Vetores que contem informacao textual sao chamados
# **character**. Podemos descobrir a classe de um vetor atraves
# da funcao **class**.

nomes = c("Camila","Joao","Leandro","Alessandro","Rita")
idades = c(13,31,38,32,19,41)

class(nomes)
class(idades)


#-------------------------------------
# Vetores (parte 3) - Vetores textuais
#-------------------------------------

# Acabamos de ver que o R tambem guarda informacoes nao numericas.
# Para armazenar dados textuais, sempre utilizamos aspas

"gilvan" # duplas
'gilvan' # ou unicas

# E podemos compor vetores textuais:
vetor_textual = c("marcos","marina","andre")
vetor_textual

# No entanto, dados e vetores textuais nao podem ser manipulados
# com operacoes matematicas. Mas ha operacoes especificas para
# vetores textuais. Uma delas, que utilizaremos com grande
# frequencia, e a funcao **paste()**. Ela concatena elementos
# textuais (de modo semelhante ao que faz a funcao CONCATENAR
# do Excel):

paste("A","galinha","atravessou","a","rua")

# Por default, os elementos sao separados por espacos. Mas
# podemos alterar isso, com o uso do argumento **sep**:

paste("A","galinha","atravessou","a","rua",sep="$$")
paste("A","galinha","atravessou","a","rua",sep="")
paste("A","galinha","atravessou","a","rua",sep=",")

frase <- paste("A","galinha","atravessou","a","rua",sep="$$")
frase

frase_separada <- c("A","galinha","atravessou","a","rua")
frase_separada

length(frase)
length(frase_separada)

#-------------------------------------------------
#### Vetores (parte 4) - Classes numeric e integer
#-------------------------------------------------

# Os numeros reais sao registrados na classe **numeric**
# (double precision). Numeros inteiros sao guardados
# como **integer**. 

4 # numeric
.5 # numeric
9L # inteiro

# A letra L apos um valor indica que ele e um numero inteiro,
# isto e, nao tem valores em casas decimais. 

class(4)
class(.5)
class(9L)

inteiros <- c(9L, 2L, 4L)
class(inteiros)
inteiros

numeric <- c(9, 2, 4)
class(numeric)
numeric

# O R aloca menos memoria para numeros inteiros, o que faz com
# que ocupem menos espaco (em disco e na memoria RAM).
# Para grandes bancos de dados, isso faz muita diferenca

# Podemos tambem extrair os elementos unicos (nao repetidos)
# de um vetor
y
unique(y)
f=c("a","galinha","atravessou","a","rua")
unique(f)

#-------------------------------------------------
# Vetores (Parte 5) - Classes de vetores unitarios
# Revisao e extensao
#-------------------------------------------------

# Numeric (numeros reais: aceitam decimais)
1
class(1)

e = 34
class(e)

f = c(3,2,2,0)
f
class(f)

# Integer (numeros inteiros, nao aceitam decimais)
1L
class(1L)

g = c(3L,2L,2L,0L)
g
class(g)

# Logical (guardam apenas as informacoes "VERDADEIRO"/"FALSO")
TRUE
FALSE
T
F
i = c(T,F,T,T,T)
i
class(i)

# Character (Informacoes de tipo texto, "string")
"Gilvan"
"Guedes"
class("Campos")
j = c("Almeida","Castro","Barbosa","Rios-Neto","Zapata")
j

# Complex
complex(real = 1, imaginary = 4)
num_complexo <- complex(real = 1, imaginary = 4)
class(num_complexo)

# Para pensar... qual a diferenca entre (?)
# "1" e 1
# "132" e 132
# "A" e "a"


#---------------------------------------------------
# Vetores (Parte 6) - Transformacao de vetores entre
# diferentes classes - Coercao implicita
#---------------------------------------------------

# Observe que nao e possivel ter dados textuais e numericos num 
# unico vetor. Quando tentamos compor um vetor "misto" usando
# a funcao **c()**, o R automaticamente transforma o resultado
# em textual. Dizemos assim que, no R, os vetores sao "atomicos".
# Isto e, nao podem pertencer a duas classes ao mesmo tempo. 
misto = c("Camila",1, 2, 3, "Joao")
class(misto)
misto=c(1L,TRUE) # TRUE sempre 1
class(misto)
misto
( misto=c(1L,FALSE) ) # FALSE sempre 0
( misto=c(4L,FALSE) )

# Quando combinamos valores de diferentes classes, automaticamente
# o R "coage" (ou "forca") o vetor para que se conforme a uma
# classe que exerce dominancia. De modo geral, a dominancia segue
# a seguinte ordem:
       
# character > numeric > integer > logic

class( x <- c(7,"a") ) #character
class( x <- c(TRUE,"Antonio") ) #character
class( x <- c(32,TRUE) ) #numeric
class( x <- c(6L, FALSE) ) #integer

# Dizemos que nesses casos houve "COECAO IMPLICITA"

#--------------------------------------------------------------
# Vetores (Parte 7) - Transformacao de vetores entre diferentes
# classes - Coercao explicita
#--------------------------------------------------------------
        
# Podemos explicitamente alterar a classe de vetor com o uso
# de funcoes com que se iniciam com 'as.' : 
        
# - as.numeric()
# - as.logical()
# - as.character()
# - etc...

x <- 0L:10L
x
class(x)

as.numeric(x)
y <- as.numeric(x)
y
class(y)

class(as.numeric(x))

as.logical(x)
as.character(x)

# Mas esse tipo de coercao nem sempre funciona:
x <- c("a","b","c")
as.numeric(x)
as.logical(x)
as.complex(x)

# Transformando um numerico em fator
x = c(1L,2L,3L,2L,1L,1L,3L)
x = factor(x,
           levels=c(1,2,3),
           labels=c("Ruim","Regular","Bom"))
x
class(x)
table(x)

if(!require(plyr)){install.packages('plyr');library(plyr)}
levels(x)=c(1,2,3)
table(x)

#--------------------------------------------------------
# Selecionando componentes dentro de vetores (subsetting)
#--------------------------------------------------------

# Como vimos, vetores sao objetos compostos, que armazemam mais
# de uma informacao ao mesmo tempo. Dizemos que vetores tem
# componentes ou elementos. Para selecionar um componente dentro
# de um vetor, utilizamos os colchetes [] e, dentro deles, 
# indicamos a posicao do objeto. O numero dentro do colchete,
# que indica a posicao do componente e chamado de **indice**.

j = c("Pedro", "Antonio", "Fernando","Claudia")
j

j[1]
j[2] 
j[20] #nao existe valor na vigesima posicao de j
j[2:4]
b["Aluno 1"]
b[1]

vetor_textual[1]
vetor_textual[2]
vetor_textual[3]

# Podemos utilizar vetores como indices. No exemplo abaixo,
# exibimos os valores do vetor_textual cujos indices (posicoes)
# sao 1,2,3:
vetor_textual
vetor_textual[1:3]
1:3
x <- 1:3
x
class(x)
vetor_textual[x]


selecao <- c(1,3)
class(selecao)
vetor_textual[selecao]
vetor_textual[c(1,3)]

class(vetor_textual[c(1,3)])

# Os indices sao muitissimo utilizados para criar subconjuntos
# ou fazer selecoes especificas. 

b
b["Aluno 1"]
b[c("Aluno 1", "Aluno 3")]


#-----------
# Sequencias
#-----------

# Ha diversas formas de criar vetores. Com os comandos **seq**
# e **:** sao bastante usados para criar sequencias de valores
# sucessivos. Usando **:**, temos os seguintes exemplos:
1:10
1:30
32:100
1.5:10  
20:1
0:-10

# No entanto, a funcao **seq** permite mais opcoes e detalhes:
seq(from = 1, to = 30)
seq(from = 1, to = 30, by=.1)
seq(1, 30, .1)
seq(5,10,length=30) #sequencia de tamanho delimitado

sequencia <- seq(5,10,length=30)
sequencia
length(sequencia)

seq(100,50,by=-.5)

# Podemos tambem criar sequencias com repeticoes com o uso
# da funcao **rep**.
rep(0, times = 40)
rep(1,10)

rep(1:3,10)
rep(c(1, 2, 4), times = 10)
rep(c(0, 1, 2), each = 10)
rep(c(TRUE,FALSE), each = 10)
rep(c("Joao","Maria"), times = 10)

Joao_Maria <- rep(c("Joao","Maria"), times = 10)
Joao_Maria[7]


#-----------------------------------
# Missing values (valores faltantes)
#-----------------------------------

# No R, os valores ou casos "perdidos" sao marcados com o simbolo 
# **NA**. As funcoes **is.na()** e **is.nan()** retornam valores 
# logicos que indicam *missing values*. 

# E importante notar que:
## - Os valores missing pertencem a classes atomicas dos vetores de 
## que fazem parte. NaN e um caso de NA (isto e, NaN e um NA, mas o 
## contrario nao e verdadeiro)

x <- c(1,2,NA,10,3.2) # Numerico!!!
class(x)
is.na(x)
is.nan(x)

# NaN - Significa "Not a number" 
0/0
is.na(0/0)
is.nan(0/0)

x <- c(1,2,NA,NaN,4)
x
class(x)
is.na(x)
is.nan(x)


#---------
# Matrizes
#---------

# Matrizes sao outra classe de objetos do R. Sao vetores cujos
# valores foram ordenados em linhas e colunas. Matrizes sao
# criadas atraves do comando **matrix()**. Devemos especificar,
# como argumentos, os dados que farao parte da matriz,
# o numero de linhas e o numero de colunas:
        
A = matrix(c(1,2,3,4,5,6,7,8),nrow=2,ncol=4)
A

# Veja no exemplo acima que o R adota a entrada dos dados da
# matriz por coluna, e nao por linha. Para mudar isso, devemos
# acionar o argumento *byrow=T*:

B = matrix(1:200,nrow=20,ncol=10, byrow = T)
head(B,5)

m <- matrix(nrow=2, ncol=3) # cria matriz de valores nulos
m

matrix(seq(1,99.9,by=.1),nrow=90,ncol=11)

matrix(1:100,nrow=90,ncol=11) # fazendo reciclagem

A
class(A)

# Para selecionar um elemento especifico de uma matriz,
# tambem utilizamos os colchetes []. 
A[5] # quinto elemento da matriz
class(A[5])

A[1,4] # elemento localizado na primeira linha, quarta coluna
class(A[1,4])

A[,2] # Segunda coluna inteira
class(A[,2])

A[1,] # primeira linha inteira

# Matrizes tambem sao vetores atomicos. Ou seja, so podem
# conter um tipo de informacao: **ou** numerica **ou** textual;
# mas nao os dois tipos ao mesmo tempo. O tamanho de uma
# matriz pode ser verificado de diferentes modos:
        
length(A) # numero de elementos
dim(A) # dimensoes da matriz, isto e, o numero de linhas e columas

dim(A)[2]

nrow(A) # numero de linhas
ncol(A) # numero de colunas

# No R e sempre importante saber com que tipo de objeto estamos
# trabalhando. Cada tipo de objeto (ou classe) tem propriedades
# especificas e sao acessadas e analisadas com o uso de funcoes
# e metodos especificos. Os comandos **nrow** e **ncol** nao
# funcionam, por exemplo com os vetores comuns. Para descobrir o 
# tipo de objeto com o qual estamos lidando, sempre devemos
# usar a funcao **class**. 

class(A) # Observem que "matrix" e um tipo de classe!


# Multiplicação de matrizes (linhas por colunas)
t(A) %*% A # deve ser conformada a multiplicacao

# Multiplicação de elementos matrizes (um a um)
A * A 

#-----------------------------
# Dataframes (bancos de dados)
#-----------------------------

# Como as matrizes, Dataframes tambem sao objetos organizados
# em linhas e colunas. Mas diferentemente das matrizes, cada
# coluna tem suas proprias propriedades e pode conter 
# informacoes de tipos diferentes. Uma coluna pode ser 'character',
# outra 'numeric'. Nesse sentido, os dataframes ocupam, no R,
# a mesma funcao dos bancos de dados nos softwares convencionais
# de estatistica e analise de dados (como SPSS ou Stata). Podemos
# entender os dataframes como um conjunto de vetores atomicos
# de diferentes tipos, que devem, no entanto, conter sempre
# o mesmo numero de componentes. Ora, num banco de dados
# todas as variaveis (colunas) tem o mesmo numero de observacoes 
# (linhas). Num dataframe e a mesma coisa.

# Para criar um dataframe, usamos a funcao **data.frame()**.
# Devemos tambem especificar o nome das colunas/variaveis:
        
dados = data.frame(Nomes=c("Antonio","Gilberto","Mauricio","Isabela"),
                   Profissoes=c("Video Maker","Comerciante","Bancario","Estudante"),
                   Cidades=c("Belo Horizonte","Sao Paulo","Belo Horizonte","Sao Paulo"),
                   Idades=c(65,50,67,19),
                   stringsAsFactors=F)
dados

# Segundo exemplo
workshop <- factor(c(1,2,1,2,1,2,1,2),
                   levels <- c(1,2,3,4),
                   labels <- c("R","Stata","SPSS","SAS"))
gender <- factor(c("f","f","f",NA,"m","m","m","m"),
                 levels <- c("f","m"),
                 labels <- c("Mulher","Homem"))
q1 <- c(1,2,2,3,4,5,5,4)
q2 <- c(1,1,2,1,5,4,3,5)
q3 <- c(5,4,4,NA,2,5,4,5)
q4 <- c(1,1,3,3,4,5,4,5)
pretest <- rnorm(n=8, mean=70, sd=5)
posttest <- rnorm(n=8, mean=80, sd=5)
meusdados <- data.frame(workshop,
                        sex=gender,q1,q2,q3,q4,
                        pretest,posttest)
meusdados

View(meusdados) # visualizando o banco de dados
str(meusdados) # entendendo a estrutura do banco de dados
if(!require(Hmisc)){install.packages('Hmisc');library(Hmisc)}
describe(meusdados) # descreve os dados

# Alterando um nome de variavel do banco de dados (coluna)
names(meusdados)
colnames(meusdados)[2] <- "genero"
names(meusdados)

# Alterando todos os nomes do banco de dados
colnames(meusdados) <- c("workshop","sex",
                         "q1","q2","q3","q4",
                         "pretest","posttest")
names(meusdados)

# Alterando o nome das linhas do banco

nomes <- c("Aldo", "Magda", "Joana",
           "Pedro", "Marcelo", "Jose", "Maria", "Ilda")
meusdados <- data.frame(nomes,workshop,
                        sex=gender,q1,q2,q3,q4,
                        pretest,posttest,
                        stringsAsFactors=FALSE,
                        row.names=NULL)

row.names(meusdados) # nome das linhas
row.names(meusdados)=meusdados$nomes
row.names(meusdados) # nome das linhas

# E facil reconhecer visualmente um dataframe. Mas uma
# avaliacao precisa pode ser feita: **data.frame** e um tipo
# especifico de objeto (classe) do R:
class(dados)
class(dados[4]) # subset da coluna idade do banco de dados
class(dados[[4]]) # vetor numerico da coluna idade

# Assim como nas matrizes, verificar o tamanho dos dataframes
# de diversas maneiras:
nrow(dados)  #numero de linhas/observcoes/casos
ncol(dados)  #numero de colunas/variaveis
dim(dados)   #dimensao do dataframe (linhas por colunas)
length(dados) #numero de colunas

# Podemos acessar elementos de um dataframe de diversas maneiras. 
dados[1] #retorna a primeira coluna (com a class data.frame)
class(dados[1])

dados[[1]] #retorna a primeira coluna (com a class "character")
class(dados[[1]])

dados[4] #retorna a quarta coluna (com a class data.frame)
class(dados[4])

dados[[4]] #retorna a quarta coluna (com a class "numeric")
class(dados[[4]])

# **E interessante verificar essa diferenca entre colchetes
# simples e duplos**. Os colchetes simples retornam um
# "sub-objeto" que possui a mesma classe que o objeto original.
# Os colchetes duplos retornam um objeto que pode ter uma classe
# diferente -- possivelmente de tipo mais simples.
# **Essa diferenca sera muito importante futuramente**.

# Elementos de dataframes tambem podem ser selecionados
# indicando coordenadas de linhas e colunas dentro de colchetes
# simples, tal como fizemos com as matrizes

dados[1,] #retorna a primeira linha (com a class data.frame)
class(dados[1,])

dados[3,4] #retorna o conteudo da terceira linha, quarta coluna
class(dados[3,4]) #(com a class numeric)

# Por fim, podemos selecionar as variaveis/colunas de um
# data.frame usando seus nomes. A funcao **names** exibe
# o nome das colunas do dataframe:
names(dados)


# E agora podemos usar esses nomes de varias maneiras:
dados["Profissoes"]  # O resultado e um dataframe
class(dados["Profissoes"])  

dados[["Profissoes"]]  # O resultado e um vetor
class(dados[["Profissoes"]])  

dados$Profissoes # O resultado e um vetor
class(dados$Profissoes)

# Podemos combinar essas formas de selecao:
dados[["Idades"]][1]  #Primeiro elemento da variavel idade
dados[["Idades"]][2:4]  # Elementos 2,3 e 4 da variavel idade

# Vamos tentar agora um tipo mais avancado de selecao:
# **todas os individuos do dataframe cuja idade e superior
# a 30 anos**. Informamos o criterio de selecao 
# das linhas dentro de colchetes simples, antes de uma
# virgula (lembrem-se: a virgula e o criterio que separa
# linhas de colunas; o que esta a esquerda da virgula diz
# respeito a linhas, o que esta a esquerda refere-se a colunas).
dados$Idades
dados$Idades > 30
dados[dados$Idades>30,]

dados[dados$Idades > 30 & dados$Idades < 66 , ]

# Usando o comando cbind para criar matrizes e data.frames
Time=c("Cruzeiro","Galo Doido","Cruzeiro","Galo Doido")
Idade <- c(14, 14, 13, 12)

cbind(Time, Idade) # matriz!!!
cbind.data.frame(Time, Idade) # data.frame!!!

# E possivel acrescentar novas informacoes ao banco de dados.
# Para acrescentar novas linhas, usamos o comando **rbind**
# (row bind):
rbind(dados,
      data.frame(Nomes="Fernando",
                 Profissoes="Bancario",
                 Cidades="Belo Horizonte",
                 Idades=28))


# E com o comando **cbind** (column bind), acrescentamos novas
# colunas ao banco
cbind(dados,
      Time=c("Cruzeiro","Galo Doido","Cruzeiro","Galo Doido"))

cbind(dados,Time)
class(cbind(dados,Time))

#------------------------------------------------
# Listas - o mais flexivel e poderoso objeto do R
#------------------------------------------------

# Podemos pensar que os objetos da classe **list** sao uma
# extensao do dataframe. Dataframes continham colunas que
# poderiam ser vetores de diversos tipos. Mas todos deveriam
# ter o mesmo tamanho...

# Listas sao objetos que contem qualquer tipo de outros objetos.
# O primeiro elemento de uma lista pode ser um vetor character
# de 100 componentes. O segundo objeto pode ser um vetor numeric
# de 50 elementos. O terceiro elemento pode ser um 
# dataframe inteiro!! E assim por diante... Nao ha nem mesmo
# o requisito de que os componentes da lista tenham o mesmo
# numero de observacoes. 

# Listas sao criadas com o comando **list()**. E devemos especificar os seus 
# componentes.
exemplo_lista = list(
        vetor_numerico = c(1,2,3,1,2,3,4,5,3,4,5),
        vetor_textual  = c("Machado de Assis foi um grande escritor brasileiro"),
        banco_de_dados = data.frame(nomes = c("Karina","Joelma","Thiago","Juliano","Janaina"),
                                    idades = c(32L,40L,23L,38L,NA),
                                    salario = c(2350.99, NA,3700,2010,NA),
                                    escolaridade=c("Superior","Medio","Superior","Medio","Medio")
        ),
        matriz = matrix(c(1,2,3,4,5,6),ncol=3,nrow=2)
)
exemplo_lista


# Justamente por essa versatilidade, pelo fato de comportarem
# simultanemente objetos de diferentes tipo, listas sao muito
# uteis e frequentemente utilizadas nas mais diversas aplicacoes.
class(exemplo_lista)

# Os componentes de uma lista sao acessados da mesma forma
# que os componentes de um dataframe. 
exemplo_lista[1] # colchetes simples: retorna o "vetor_numerico",
                 # que e o primeiro componente da lista. Mas com
                 # a classe "list"
class(exemplo_lista[1])

exemplo_lista["vetor_numerico"] # identico ao anterior
class(exemplo_lista["vetor_numerico"])

exemplo_lista[[1]] # com os colchetes duplos, obtemos um objeto com a classe "numeric"
class(exemplo_lista[[1]])

exemplo_lista[["vetor_numerico"]] # identico ao anterior
class(exemplo_lista[["vetor_numerico"]])

exemplo_lista$vetor_numerico # Usando o $ obtemos os mesmos
                             # resultados dos colchetes duplos
exemplo_lista$vetor_textual

exemplo_lista$banco_de_dados[2] #podemos fazer selecoes mais precisas
exemplo_lista$banco_de_dados[[2]]
exemplo_lista$banco_de_dados[2,1]

exemplo_lista[[4]]
exemplo_lista[[4]][2,]
exemplo_lista[[4]][2,3]

exemplo_lista$matriz[2,]

#------------------------------------------------------------
# Funcoes genericas que serao importantes para a segunda aula
#------------------------------------------------------------

# Definindo um diretorio

getwd() # procura o diretorio atual em que o R esta acessando
setwd("/Users/grguedes/Dropbox/UFMG/Workshops/Introdução ao R/Aula 01/") # muda o diretorio

# Buscando auxilio (ajuda)

help(lm) # para funcao especifica
?lm

help.search("lm") # quando nao conhece o nome da funcao
??lm

RSiteSearch("linear model") # buscar tudo que tem a ver com linear model

# Atualizando os pacotes R no seu computador
local({r <- getOption("repos")
      r["CRAN"] <- "http://www.vps.fmvz.usp.br/CRAN/"
      options(repos=r)})
#update.packages()

# Como listar todos os objetos criados em seu Workspace
ls()

# Verificando quais bibliotecas estao instaladas
library()
installed.packages()

# Verificando quais bibliotecas estao ativas

search()

# Buscando informacoes detalhadas de uma biblioteca
?datasets
library(help="datasets")

# Instalando e carregando bibliotecas

if(!require(ggplot2)){install.packages('ggplot2');library(ggplot2)}

# Como desabilitar um pacote durante uma sessao

search()
if(!require(ggplot2)){install.packages('ggplot2');library(ggplot2)}
detach(package:Hmisc, unload = TRUE, force=TRUE)
search()

# Deletando uma biblioteca
remove.packages("Hmisc")

# Acessando bancos de dados de treinamento do R
data()

# Salvando seus objetos

save.image(file="todosObjetos.RData") # salva todo o workspace
save(matA=A, matB=B, file="meusObjetos.RData") # salva objetos selecionados

# Limpar todos os objetos no seu workspace

rm(list=ls(all=TRUE))

# Carregando um arquivo RData
load('todosObjetos.RData')

# Como remover objetos especificos
rm(A,B)
load('meusObjetos.RData')

# Para salvar o historico completo
#savehistory(file="meuHistorico.RHistory")

# Para carregar o historico completo
#loadhistory(file="meuHistorico.RHistory")

# Saindo da sessao do R
quit("yes")